<template>
  <div class="documents">
    <ObTable
      ref="documents-table"
      :columns="columns"
      :functional-panel="true"
      :show-add-button="true"
      :is-functional-group="false"
      :is-functional-sort="false"
      :table-layout-fixed="true"
      :remote-opt="{
        method,
        contentKey: 'documents',
        arguments: { uuid }
      }"
      @add="onAdd"
      @select="onSelect"
    >
      <template v-slot:loadScans="{ data }">
        <div class="document-files">
          <div
            v-for="file in data.item.files"
            :key="file.uuid"
            @click="downloadDocument(file)"
            class="document-files__item"
          >
            {{ file.name }}
          </div>
        </div>
      </template>
    </ObTable>

    <ObModal
      ref="add-document"
      :title="modalTitle"
      :title-second="modalTitleSecond"
      size="medium"
      @close="rerenderModal"
    >
      <AddDocument
        :data-source="selectedData"
        :elementUuid="uuid"
        :type="type"
        :key="addDocumentRenderKey"
        @close="closeModal"
      />
    </ObModal>
  </div>
</template>

<script>
  import api from '@/api'
  import { mapGetters } from 'vuex'
  import moment from 'moment'
  import ObTable from 'common-components/src/obComponents/obTable'
  import ObModal from "common-components/src/obComponents/obModal"
  import AddDocument from './document-modal'

  export default {
    name: 'documents-tab',
    components: {
      ObTable,
      ObModal,
      AddDocument
    },
    computed: {
      ...mapGetters({
        participantUuid: 'user/participantUuid'
      }),

      uuid: ({ $route, participantUuid }) => $route.params.uuid || participantUuid
    },
    props: {
      method: {
        type: Function,
        required: true
      },
      withEditing: {
        type: Boolean,
        default: false
      },
      type: { // resources or organisations
        type: String,
        required: true
      }
    },
    data () {
      return {
        api,
        selectedData: null,
        modalTitle: null,
        modalTitleSecond: null,
        columns: [
          {
            title: '№',
            key: 'number',
            exactWidth: '70px',
            html: ({ number, archivedAt }) => this.getValue(this.type === "organisations" ? number : number + 1, archivedAt)
          },
          {
            title: 'Тип документа',
            key: 'type_document',
            exactWidth: '28%',
            html: ({ docTypeTitle, archivedAt }) => this.getValue(docTypeTitle, archivedAt, archivedAt)
          },
          {
            title: 'Загруженные сканы',
            key: 'scans',
            exactWidth: '29%',
            slotName: 'loadScans'
          },
          {
            title: 'Комментарий',
            key: 'comment',
            exactWidth: '26%',
            html: ({ comment, archivedAt }) => this.getValue(archivedAt ? 'Документ удалён' : comment, archivedAt)
          },
          {
            title: 'Изменен',
            key: 'changed',
            html: ({ updatedAt, archivedAt }) => this.getValue(moment(updatedAt).format('DD.MM.YYYY, HH:mm'), archivedAt)
          }
        ],
        addDocumentRenderKey: 0
      }
    },
    methods: {
      getValue (value, isDeleted = false, isCrossed = false) {
        const classes = []

        if (isDeleted) {
          classes.push('document_deleted')
        }

        if (isCrossed) {
          classes.push('document_crossed')
        }

        return `<span class="${classes.join(' ')}">${value || ''}</span>`
      },
      onAdd () {
        this.modalTitle = 'Новый документ';
        this.modalTitleSecond = 'Добавление';
        this.selectedData = null;

        this.$refs['add-document'].open();
      },
      onSelect (data) {
        // Cannot edit deleted documents
        if (data['archivedAt'] || !this.withEditing) {
          return
        }

        this.modalTitle = 'Документ';
        this.modalTitleSecond = 'Редактирование';
        this.selectedData = data;

        this.$refs['add-document'].open();
      },
      async downloadDocument (file) {
        const response = await api.files.getSecurityFile(file.uuid)

        const fileName = response.name
        const url = window.URL.createObjectURL(new Blob([response.data]))
        const link = document.createElement('a')

        link.href = url
        link.setAttribute('download', fileName)

        document.body.appendChild(link)

        link.click()

        document.body.removeChild(link)
      },
      closeModal () {
        this.$refs['add-document'].close();
        this.$refs['documents-table'].loadData({ init: true });
      },
      rerenderModal () {
        // Need for re-rendering modal window after close
        this.addDocumentRenderKey += 1;
      }
    }
  }
</script>

<style lang="scss" scoped>
  .documents::v-deep {
    .document {
      &_deleted {
        color: $gray-slate;
      }

      &_crossed {
        letter-spacing: .2px;
        text-decoration-line: line-through;
      }
    }
  }

  .document-files {
    display: flex;
    flex-wrap: wrap;
    margin-bottom: -6px;

    &__item {
      color: $color-blue-navy-blue;
      background-color: $blue-250;
      border-radius: 10px;
      margin: 0 6px 6px 0;
      padding: 5px 12px;
      cursor: pointer;
    }
  }
</style>
